package cn.ibizlab.core.uaa.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.core.uaa.domain.SYS_USER_ROLE;
import cn.ibizlab.core.uaa.filter.SYS_USER_ROLESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[SYS_USER_ROLE] 服务对象接口
 */
public interface ISYS_USER_ROLEService extends IService<SYS_USER_ROLE>{

    boolean checkKey(SYS_USER_ROLE et) ;
    SYS_USER_ROLE getDraft(SYS_USER_ROLE et) ;
    boolean update(SYS_USER_ROLE et) ;
    void updateBatch(List<SYS_USER_ROLE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(SYS_USER_ROLE et) ;
    void createBatch(List<SYS_USER_ROLE> list) ;
    SYS_USER_ROLE get(String key) ;
    boolean save(SYS_USER_ROLE et) ;
    void saveBatch(List<SYS_USER_ROLE> list) ;
    Page<SYS_USER_ROLE> searchDefault(SYS_USER_ROLESearchContext context) ;
    List<SYS_USER_ROLE> selectByRoleid(String roleid) ;
    void removeByRoleid(String roleid) ;
    void saveByRoleid(String roleid,List<SYS_USER_ROLE> list) ;
    List<SYS_USER_ROLE> selectByUserid(String userid) ;
    void removeByUserid(String userid) ;
    void saveByUserid(String userid,List<SYS_USER_ROLE> list) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


